import java.io.*;
import java.net.*;

public class Dsap
{
	// Some constants
	public static final String SERVER_NAME = "wolverine";
	public static final short SERVER_PORT = 12360;
	private static final short LOCAL_PORT = 9877;

	InetAddress localAddr;
	DatagramPacket pkt;
	DatagramSocket sock;

	InetAddress servAddr;

	DataInputStream moviefile;

	public void SetupSocket()
	{
		try
		{
			localAddr = InetAddress.getLocalHost();
			servAddr = InetAddress.getByName(SERVER_NAME);
		}
		catch(UnknownHostException e)
		{
			Log.err("Unable to get my host address: " + e.toString());
		}

		try
		{
			sock = new DatagramSocket();
			Log.log("Socket Opened");
		}
		catch(SocketException e)
		{
			Log.err("Unable to create datagram socket: " + e.toString());
		}
	}

	public void SendMovieRequest(byte mc_addr[])
	{
		pkt = new DatagramPacket(mc_addr, 4, localAddr, LOCAL_PORT);
		try
		{
			sock.send(pkt);
		}
		catch(IOException e)
		{
			Log.err("Unable to send packet: " + e.toString());
		}
	}

	public void StartMovie(short movie_num)
	{
		byte b[] = new byte[3];
		b[0] = 1;
		b[1] = (byte)((movie_num&0xff00) >> 8);
		b[2] = (byte)(movie_num & 0xff);
		pkt = new DatagramPacket(b, 3, servAddr, SERVER_PORT);
		try
		{
			sock.send(pkt);
			Log.log("Start Packet sent");
		}
		catch(IOException e)
		{
			Log.err("Unable to send packet: " + e.toString());
		}
	}

	public void Pause(short movie_num)
	{
		byte b[] = new byte[3];
		b[0] = 3;
		b[1] = (byte)((movie_num&0xff00) >> 8);
		b[2] = (byte)(movie_num & 0xff);
		pkt = new DatagramPacket(b, 3, servAddr, SERVER_PORT);
		try
		{
			sock.send(pkt);
		}
		catch(IOException e)
		{
			Log.err("Unable to send packet: " + e.toString());
		}
	}

	public void Resume(short movie_num)
	{
		byte b[] = new byte[3];
		b[0] = 4;
		b[1] = (byte)((movie_num&0xff00) >> 8);
		b[2] = (byte)(movie_num & 0xff);
		pkt = new DatagramPacket(b, 3, servAddr, SERVER_PORT);
		try
		{
			sock.send(pkt);
		}
		catch(IOException e)
		{
			Log.err("Unable to send packet: " + e.toString());
		}
	}
	public void Quit(short movie_num)
	{
		byte b[] = new byte[3];
		b[0] = 5;
		b[1] = (byte)((movie_num&0xff00) >> 8);
		b[2] = (byte)(movie_num & 0xff);

		pkt = new DatagramPacket(b, 3, servAddr, SERVER_PORT);
		try
		{
			sock.send(pkt);
		}
		catch(IOException e)
		{
			Log.err("Unable to send packet: " + e.toString());
		}
		byte c[] = new byte[4];
		pkt = new DatagramPacket(c, 4, localAddr, LOCAL_PORT);
		try
		{
			sock.send(pkt);
		}
		catch(IOException e)
		{
			Log.err("Unable to send packet: " + e.toString());
		}
	}
	
	public String[] getTitles(URL Base)
	{
		String tmp = new String();
		int i, j;
		String[] list;

		URL myURL = null;
		
		try
		{
		  myURL = new URL(Base, "movies.dat");
		}
		catch(MalformedURLException e)
		{
		  Log.err("Unable to make URL");
		}

		try
		{
			moviefile = new DataInputStream(myURL.openStream());
		}
		catch(Exception e)
		{
			Log.err("Unable to open movie file");
		}

		try
		{
			tmp = moviefile.readLine();
		}
		catch(IOException e)
		{
			Log.err("Unable to read number of movies");
		}
		
		i = Integer.parseInt(tmp);
		list = new String[i];
		for (j=0; j<i; j++)
		{
			try
			{
				list[j] = new String(moviefile.readLine());
			}
			catch(IOException e)
			{
				Log.err("Unable to read movie name "+j);
			}
		}
		return list;
	}
}
