import java.io.*;
import java.net.*;
import java.util.*;

public class Dsap
{
  // Some constants
  public static final String SERVER_NAME = "wolverine";
  public static final short SERVER_PORT = 12360;
  private static final short LOCAL_PORT = 9877;

  InetAddress localAddr;
  DatagramPacket pkt;
  DatagramSocket sock;

  InetAddress servAddr;

  DataInputStream moviefile;

  public void SetupSocket()
  {
    try
    {
      localAddr = InetAddress.getLocalHost();
      servAddr = InetAddress.getByName(SERVER_NAME);
    }
    catch(UnknownHostException e)
    {
      Log.err("Unable to get my host address: " + e.toString());
    }

    try
    {
      sock = new DatagramSocket();
      //Log.log("Socket Opened");
    }
    catch(SocketException e)
    {
      Log.err("Unable to create datagram socket: " + e.toString());
    }
  }

  public void SendMovieRequest(byte mc_addr[])
  {
    pkt = new DatagramPacket(mc_addr, 4, localAddr, LOCAL_PORT);
    try
    {
      sock = new DatagramSocket();
      sock.send(pkt);
    }
    catch(IOException e)
    {
      Log.err("Unable to send packet: " + e.toString());
    }
  }

  public void StartMovie(short movie_num)
  {
    byte b[] = new byte[3];
    b[0] = 1;
    b[1] = (byte)((movie_num&0xff00) >> 8);
    b[2] = (byte)(movie_num & 0xff);
    pkt = new DatagramPacket(b, 3, servAddr, SERVER_PORT);
    try
    {
      sock = new DatagramSocket();
      sock.send(pkt);
      //Log.log("Start Packet sent");
    }
    catch(IOException e)
    {
      Log.err("Unable to send packet: " + e.toString());
    }
  }

  public void Pause()
  {
    byte b[] = new byte[1];
    b[0] = 3;
    pkt = new DatagramPacket(b, 1, servAddr, SERVER_PORT);
    try
    {
      sock = new DatagramSocket();
      sock.send(pkt);
    }
    catch(IOException e)
    {
      Log.err("Unable to send packet: " + e.toString());
    }
  }

  public void Resume()
  {
    byte b[] = new byte[1];
    b[0] = 4;
    pkt = new DatagramPacket(b, 1, servAddr, SERVER_PORT);
    try
    {
      sock = new DatagramSocket();
      sock.send(pkt);
    }
    catch(IOException e)
    {
      Log.err("Unable to send packet: " + e.toString());
    }
  }
  public void Quit()
  {
    byte b[] = new byte[1];
    b[0] = 5;

    pkt = new DatagramPacket(b, 1, servAddr, SERVER_PORT);
    try
    {
      sock = new DatagramSocket();
      sock.send(pkt);
    }
    catch(IOException e)
    {
      Log.err("Unable to send packet: " + e.toString());
    }
    byte c[] = new byte[4];
    c[0] = 0; c[1] = 0; c[2] = 0; c[3] = 1;
    pkt = new DatagramPacket(c, 4, localAddr, LOCAL_PORT);
    try
    {
      sock = new DatagramSocket();
      sock.send(pkt);
    }
    catch(IOException e)
    {
      Log.err("Unable to send packet: " + e.toString());
    }
    System.exit(1);
  }
	
  public String[] getTitles(URL Base)
  {
    String tmp = new String();
    int i, j, k;
    String[] list;
    String[] asd;
    StringTokenizer stoken;

    URL myURL = null;
		
    try
    {
      myURL = new URL(Base, "movies.dat");
    }
    catch(MalformedURLException e)
    {
      Log.err("Unable to make URL");
    }

    try
    {
      moviefile = new DataInputStream(myURL.openStream());
    }
    catch(Exception e)
    {
      Log.err("Unable to open movie file");
    }

    asd = new String[1024];
    for (j=0;j<1024;j++)
    {
      try
      {
	tmp = moviefile.readLine();
      }
      catch(IOException e)
      {
	break;
      }
      if (tmp==null)
	break;
      stoken = new StringTokenizer(tmp);
      //System.out.println(tmp);
      try 
      {
	k = stoken.nextToken().length();
      }
      catch(Exception e)
      {
	break;
      }
      asd[j] = tmp.substring(k+1);
    }

    list = new String[j];
    for (i=0; i<j; i++) list[i] = asd[i];

    return list;
  }
}

