import java.io.*;
import java.net.*;
import java.util.*;

public class DsapListener extends Thread
{
  DatagramSocket sock;
  Dsap dsap;
  DatagramPacket packet;

  DsapListener(Dsap ds)
  {
    dsap = ds;

    try
    {
      sock = new DatagramSocket(12362);
    }
    catch(Exception e)
    {
      Log.err("Unable to bind: " + e.toString());
    }
  }

  public void run()
  {
    byte[] buf = new byte[8];
    int i;

    while (true)
    {
      packet = new DatagramPacket(buf, 8);

      try
      {
	sock.receive(packet);
      }
      catch(IOException ex)
      {
	Log.err("Unable to receive packet: " + ex.toString());
      }
    
      switch(buf[0])
      {
      case 2: /* CC_SWITCH_CHANNEL */
	//System.out.println("Received channel");
	for (i=0; i<4; i++) buf[i] = buf[i+1];
	// for (i=0; i<4; i++) System.out.print(" " + (int)buf[i]);
	//System.out.println("");
	dsap.SendMovieRequest(buf);
	break;
      }
    }
  }
}

    
