#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/time.h>

#include "xpbasic.h"
#include "msg.h"
#include "vrec2.h"
#include "player2.h"
#include "client.h"

#define DUMMY_ADDR "192.1.0.1"
#define DUMMY_PORT 54321

void sigh(int i)
{
	log("Aaargh! Caught SIGSEGV. Terminating");
	abort();
}

void main(int argc, char **argv)
{
	fd_set rfds, wfds;
	struct timeval tv;
	int n, retval;
	int order;
	
	if (argc!=2)
		err("Requires a file name ");

	log("MAIN: Starting up");
	setup_pool();

	vrec_setup();
	client_setup(argv[1]);

	log("MAIN: setting up player");
	player_setup();
	warn("Player is now ready");
	while (1)
	{
		FD_ZERO(&rfds);
		FD_ZERO(&wfds);
		FD_SET(clientfd, &rfds);
		FD_SET(vsock_fd, &rfds);
		FD_SET(pipefd, &wfds);
		n = clientfd; if (n<vsock_fd) n=vsock_fd; if (n<pipefd) n=pipefd;
		n++;
		tv.tv_sec = 0;
		tv.tv_usec = 50;

		retval = select(n, &rfds, &wfds, NULL, &tv);

		if (retval)
		{
			if (order%2 == 0)
			{
				if (FD_ISSET(pipefd, &wfds)) { if (playout_enable) player_do(); }
				if (FD_ISSET(vsock_fd, &rfds)) vrec_do();
				if (FD_ISSET(clientfd, &rfds)) client_do();
			}
			else 
			{
				if (FD_ISSET(vsock_fd, &rfds)) vrec_do();
				if (FD_ISSET(pipefd, &wfds)) { if (playout_enable) player_do(); }
				if (FD_ISSET(clientfd, &rfds)) client_do();
			}
			order++;
		}
	}
}

