#include <stdio.h>
#include <fcntl.h>

unsigned char packet_start[] = {0x00, 0x00, 0x01, 0xe0};
unsigned char packet_rest[]  = {0x0f};

void main(int argc, char **argv)
{
	int f1, f2, f3;
	unsigned char buf[1024];
	unsigned char ln[2];
	int i;

	if (argc!=4)
	{
		printf("Usage: %s system_header_file vsh_file out_file\n", argv[0]);
		exit(1);
	}

	f1 = open(argv[1], O_RDONLY);
	if (f1 < 0)
	{
		printf("Unable to open file %s\n", argv[1]);
		exit(1);
	}

	f2 = open(argv[2], O_RDONLY);
	if (f2 < 0)
	{
		printf("Unable to open file %s\n", argv[2]);
		exit(1);
	}
	
	f3 = open(argv[3], O_WRONLY | O_CREAT | O_TRUNC, 0644);
	if (f3 < 0)
	{
		printf("Unable to open file %s\n", argv[3]);
		exit(1);
	}

	i = read(f1, buf, 1024);
	printf("Writing system header - %d bytes\n", i);
	write(f3, buf, i);

	i = read(f2, buf, 1024);
	ln[0] = ((i+1)>>8) & 0xff;
	ln[1] = (i+1)&0xff;
	printf("Writing packet header - %d bytes\n", sizeof(packet_start));
	write(f3, packet_start, sizeof(packet_start));
	printf("Writing length - %d bytes\n", 2);
	write(f3, ln, 2);
	printf("Writing packet rest - %d bytes\n", sizeof(packet_rest));
	write(f3, packet_rest, sizeof(packet_rest));
	printf("Writing video sequence header - %d bytes\n", i);
	write(f3, buf, i);

	close(f1);
	close(f2);
	close(f3);
}
	
