/*================================================================

File: vrec2.h

Title: Video Receiver

Author: Ashok

Purpose:
This module receives and resequences the video packets
from the network

================================================================*/

#if !defined(_VREC)
#define _VREC

#include "xpbasic.h"

/* No. of GOPs to buffer initially */
#define N_GOP 6

extern pkt *first, *last;
extern pkt *curr_gop_hdr, *second_gop_hdr;
extern int n_gop;

extern int vsock_fd;

#define VIDEO_PORT 12345

/* ----------- Function headers -------------- */

void vrec_setup();

void init_video_socket();
/* Open a socket */

void vrec_exit(void);
/* Closes the video socket */

void vrec_join(unsigned long srv_multicast_addr);
/* Joins the specified group. It must be converted using inet_addr. */

void vrec_leave();
/* Leaves the group */

void vrec_do(void);
/* This function gets a packet off the network and 
	places it into the buffers after sequencing.
	A new block of memory is allocated for this packet
	If no packet is available, it returns immediately */

#endif
