/*================================================================

File: xpbasic.h

Title: Basic XP functions/utils

Author: Ashok

Purpose:
Some basic functions/data structures for the MPEG Transport Module

================================================================*/

#if !defined(_XPBASIC)
#define _XPBASIC

#define PKT_SIZE 576

/* --------- Packet sequencing primitives ---------- */

/* Structure of a packet */
typedef struct pkt_struct
{
	unsigned char data[PKT_SIZE];

	/* information extracted from the data */
	int size, gop_num, frame_num, frame_part, num_of_parts, frag_num, total_frags, curr_type;
	unsigned char *out_data;
	unsigned long tstampl, tstamph;

	/* Pointers for packet queue */
	struct pkt_struct *prev, *next;
	
	/* The next two pointers are used by the pool mgr */
	struct pkt_struct *pool_prev, *pool_next;
} pkt;

/* ----------- Function headers -------------- */

void init_MPEG_player(void);
/* This function starts up the MPEG player */

void close_MPEG_player(void);
/* This function closes the MPEG player */

void init_ctrl_socket(void);
/* This function inits the control socket */

void close_ctrl_socket(void);
/* This function closes the control socket */

void put_video_pkt(pkt *);
/* This function puts a packet out to the MPEG player 
	The memory belonging to this packet is freed.  */

void get_ctrl_pkt(void);
/* This function gets a control packet. If no packet
	is availabe, it returns immediately */


#endif
