#ifndef AGENT_H
#define AGENT_H

#include "dsap.h"

typedef struct client_st
{
    unsigned long hostid;
    struct client_st *next;
} client_t;

typedef struct stream_st
{
    unsigned long stream_id;
    int movie_id;
    unsigned long frame_num;
    client_t *clients;
    struct stream_st *next;
} stream_t;

char *movielist[1024];
int num_movies;

extern FILE *fperr;

stream_t *stream_list;

#define BASE_MCAST_ADDR "227.0.0.1"

/* sends a message to a client */
void send_to_client(unsigned long hostid, char code, unsigned long mc_addr);

/* Load the movie list */
void read_movies();

/* create a new stream and add it to the list */
stream_t *create_stream(int movie_id, unsigned long start_frame_num);

/* Create a new client and add it to a stream. This function sends the requisite message to the client */
void add_client_to_stream(stream_t *stream, unsigned long hostid);

/* remove a client from a stream */
void remove_client_from_stream(stream_t *stream, unsigned long hostid);

/* find a client in the stream list */
stream_t *find_client(unsigned long hostid);

#endif
