#ifndef _DSAP_H
#define _DSAP_H

#ifndef MAX_LINE
#define MAX_LINE 4096
#endif

typedef struct
{
	unsigned short          ID;                       /* identifier */
	unsigned short          status;                   /* status of the entry */
	unsigned char           filename[MAX_LINE];       /* Name of the file */
	unsigned long           multiaddr;                /* multicast group to join */ 
	unsigned short          portnum;                  /* Port to listen on */
	unsigned long           filepos;                  /* File position to read from */
	int                     currframe;                /* Current frame number */
} LOGINTABLE;

#define LONG_SWAP(iv, cp)  (cp)[0] = (iv) >> 24;\
                         (cp)[1] = ((iv) >> 16) & 0xFF;\
                         (cp)[2] = ((iv) >> 8) & 0xFF;\
                         (cp)[3] = (iv) & 0xFF;

#define SHORT_SWAP(iv, cp) (cp)[0] = (iv) >> 8;\
                          (cp)[1] = (iv) & 0xFF;


#define S_ACTIVE            1

#define S_NEWREQUEST        2
#define S_STARTING          4

#define S_STOPREQUEST       8 
#define S_STOPPING         16
#define S_STOPPED          32

#define S_PAUSED          128

#define DSAP_PORTNUM      12360
#define DSAP_OUT_PORTNUM  12362
#define VIDEO_PORTNUM     12345

#endif
