#ifndef __SESSION_H__
#define __SESSION_H__           /* To prevent multiple includes */

#include <sys/socket.h>
#include <sys/time.h>
#include "vcripc.h"
#include "tellwait.h"


#define MAXLINE                 4096         /* max line length */
#define BUFSIZE                 100000       /* size of buffer (BYTEs) */
#define MAX_ENTITIES            255          /* maximum number of entities */
#define GOP_SIZE_LIMIT          200000       /* maximum size of a GOP */
#define MAX_FRAMES              15           /* maximum number of frames in a GOP */
#define MAX_NUM_OF_FRAMES       20000        /* maximum number of frames in a movie */

#define min(x,y) ((x<=y)?x:y)

typedef struct {
    unsigned char     curr_type;
    unsigned char     frame_num;
    unsigned char     frame_part;
    unsigned char     num_of_parts;
    int      		      size;
    int      		      skip_15_offset;
} entity;

typedef struct {
      entity ent[MAX_ENTITIES];
}header;

struct sess_info {
    unsigned long       id;            /* session id */
    BYTE                status;        /* status of this stream */
    int                 fd;            /* file descriptor to read from */
    int                 fdframe;       /* file descriptor for frame offsets file */
    int                 num_of_frames; /* number of frames in the movie file */
    int                 currframe;
    long                file_len;      /* length of the movie file in bytes */
    int                 on; 
    struct sockaddr_in  to;            /* address to send to */
    unsigned char      *frbuf[15];     /* ptr to data buffer */
    struct sess_info   *next;          /* ptr to next session */
};

/*
typedef struct _list_pos {
    unsigned long id;
    unsigned long file_pos;
} list_pos;

typedef struct _list_gop {
    unsigned long id;
    short gop_num;
} list_gop;
*/

/********************************************************************************************/

void init_serv();
void check_shmem();
void rate_adapt(LOGINTABLE *);
void enter_stream_ids(int *, unsigned long, unsigned long);
/*
unsigned long filepos(unsigned long, unsigned long, char);
short gopnum(unsigned long, list_gop []);
*/

void server_cleanup(unsigned long);
void init_sess(LOGINTABLE *);
void create_sess(LOGINTABLE *);
void remove_sess(unsigned long);

/*
void read_header(int, BYTE, header *);
void read_data(list_pos []);
void write_data(list_gop []);
*/

void write_entity(char *, int, struct sockaddr *, int, entity *, 
		 short, unsigned long);
int put_entity(int, char *, int, struct sockaddr *, int, entity *,
	      short, unsigned long);
void sleep_us(double nusecs);

#endif  /* __SESSION_H__ */
