#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "error.h"

extern char *pname;
static int	pfd1[2], pfd2[2];

void
TELL_WAIT()
{
	if (pipe(pfd1) < 0 || pipe(pfd2) < 0)
		err_sys("%s: ERROR: TELL_WAIT: pipe error", pname);
}

void
TELL_PARENT()
{
	if (write(pfd2[1], "c", 1) != 1)
		err_sys("%s: ERROR: TELL_PARENT: pipe write error", pname);
}

void
WAIT_PARENT(void)
{
	char	c;
	static int i;

	do
		i = read(pfd1[0], &c, 1);
	while (i !=1 && errno == EINTR);

	if (i != 1)
		err_sys("%s: ERROR: WAIT_PARENT: pipe read error %d %d ", pname, errno, EINTR);
	if (c != 'p')
		err_quit("%s: ERROR: WAIT_PARENT: incorrect data", pname);
}

void
TELL_CHILD()
{
	if (write(pfd1[1], "p", 1) != 1)
		err_sys("%s: ERROR: TELL_CHILD: pipe write error", pname);
}

void
WAIT_CHILD(void)
{
	char	c;
	static int i;

	do
		i = read(pfd2[0], &c, 1);
	while (i !=1 && errno == EINTR);

	if (i!=1)
		err_sys("%s: ERROR: WAIT_CHILD: pipe read error %d %d", pname, errno, EINTR);
	if (c != 'c')
		err_quit("%s: ERROR: WAIT_CHILD: incorrect data", pname);
}
