/* Some utility functions */

#include "util.h"

/* Determine the size in bytes of a file */
long filelen(int fd)
{
	long len;
	/* Go to the end of the file */
	if ((len = lseek(fd, 0L, SEEK_END)) == -1)
		return -1;
	/* Put file pointer back to start */
	lseek(fd, 0L, SEEK_SET);
	return len;
}
      
/* Reads an integer */
int READ_INT(int fildes)
{
	unsigned char cp[4]; 
	read(fildes,cp,4);
	return (((int)(cp[0])) << 24 )
		+(((int)(cp[1])) << 16 )
		+(((int)(cp[2])) << 8  )
		+(((int)(cp[3])));
}


long READ_LONG(int fildes)
{
	unsigned char cp[4];
	if (read(fildes,cp,4) != 4)
	{
		raise(11);
		err_sys("Read_Long Failed");
	}
	
	return (((long)(cp[0])) << 24 )
		+(((long)(cp[1])) << 16 )
		+(((long)(cp[2])) << 8  )
		+(((long)(cp[3])));
}


/* Reads an unsigned character */  
unsigned char READ_UCHAR(int fildes)
{
	unsigned char cp;
	read(fildes,&cp,1);
	return cp;
}

/* Amount of data sent to client - in bytes */
void mklength(unsigned short nb, unsigned char cp[])
{
  cp[0] = (nb >> 8) & 0xff;
  cp[1] = nb & 0xff;
}

/* Time stamp for packets sent to client */
void mktstamp(unsigned long id, unsigned long fp, unsigned char ts[])
{
  ts[0] = (fp >> 24) & 0xff;
  ts[1] = (fp >> 16) & 0xff;
  ts[2] = (fp >> 8) & 0xff;
  ts[3] = fp & 0xff;
  ts[4] = (id >> 24) & 0xff;
  ts[5] = (id >> 16) & 0xff;
  ts[6] = (id >> 8) & 0xff;
  ts[7] = id & 0xff;
}

/*
 * Just a time stamp for logfiles. 
 * Returns current date and time.
 */
char *tstamp(void)
{
	time_t t;
	t = time(0);
	return ctime(&t);
}






