/*   This header file contains prototypes of functions used for */
/*   handling IPCs. Some macro definitions and a structure      */
/*   declaration for holding the login table are also to be     */
/*   found in this file.                                        */

#ifndef __VCRIPC_H__     /* To prevent multiple includes */
#define __VCRIPC_H__

#define MAX_LINE 4096
#define NSERVERS 5

#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include "vcrctrl.h"
#include "dsap.h"

#define SHMKEY0 ((key_t) 9011)      /* base value for shared memory key */
#define SEMKEY0 ((key_t) 9012)      /* semaphore key */

#define SHMKEY ((key_t) 9013)      /* base value for shared memory key */
#define SEMKEY ((key_t) 9014)      /* semaphore key */

#define SHMKEY2 ((key_t) 9015)      /* base value for shared memory key */
#define SEMKEY2 ((key_t) 9016)      /* semaphore key */

#define PERMS 0666                 /* Permissions on the IPCs */

/***********************************************************************/
/**********   Semaphore function prototypes   **************************/
/***********************************************************************/
int sem_create(); /*create with initial value or open */
int sem_open();                /*open (must already exist)  */
int sem_wait();                   /*wait = P = down by 1       */
int sem_signal();                 /*signal = V = up by 1       */
int sem_op();         /*wait if (amount < 0)       */
                                        /*signal if (amount > 0)     */
int sem_close();                  /*close                      */
int sem_rm();                     /*remove (delete)            */

/***********************************************************************/
/**********   Shared  Memory  function prototypes   ********************/
/***********************************************************************/
void purge_logins();
LOGINTABLE *find_empty();
LOGINTABLE *find_pid();
LOGINTABLE *find_entry();

#endif /* !__VCRIPC_H__ */







